Index: include/video_output.h
===================================================================
RCS file: /var/cvs/videolan/vlc/include/video_output.h,v
retrieving revision 1.107
diff -u -r1.107 video_output.h
--- include/video_output.h	11 Dec 2003 23:12:46 -0000	1.107
+++ include/video_output.h	21 Feb 2004 23:12:27 -0000
@@ -83,6 +83,7 @@
     vlc_bool_t          b_info;            /**< print additional information */
     vlc_bool_t          b_interface;                   /**< render interface */
     vlc_bool_t          b_scale;                  /**< allow picture scaling */
+    float               f_zoom;       /**< zoom factor, used if b_scale is 0 */
     vlc_bool_t          b_fullscreen;         /**< toogle fullscreen display */
     vlc_bool_t          b_override_aspect;       /**< aspect ratio overriden */
     uint32_t            render_time;           /**< last picture render time */
Index: src/video_output/video_output.c
===================================================================
RCS file: /var/cvs/videolan/vlc/src/video_output/video_output.c,v
retrieving revision 1.245
diff -u -r1.245 video_output.c
--- src/video_output/video_output.c	25 Jan 2004 17:16:06 -0000	1.245
+++ src/video_output/video_output.c	21 Feb 2004 23:12:38 -0000
@@ -285,6 +285,7 @@
     p_vout->b_info       = 0;
     p_vout->b_interface  = 0;
     p_vout->b_scale      = 1;
+    p_vout->f_zoom       = 1;
     p_vout->b_fullscreen = 0;
     p_vout->i_alignment  = 0;
     p_vout->render_time  = 10;
@@ -319,6 +320,10 @@
 
     p_vout->b_override_aspect = VLC_FALSE;
 
+    /* Set p_vout->f_zoom for use in InitWindowSize and vout_PlacePicture */
+    var_Get( p_vout, "zoom", &val );
+    p_vout->f_zoom = val.f_float;
+
     /* If the parent is not a VOUT object, that means we are at the start of
      * the video output pipe */
     if( p_parent->i_object_type != VLC_OBJECT_VOUT )
@@ -1264,8 +1269,8 @@
     i_width = val.i_int;
     var_Get( p_vout, "height", &val );
     i_height = val.i_int;
-    var_Get( p_vout, "zoom", &val );
-    ll_zoom = (uint64_t)( FP_FACTOR * val.f_float );
+
+    ll_zoom = (uint64_t)( FP_FACTOR * p_vout->f_zoom );
 
     if( i_width > 0 && i_height > 0)
     {
Index: src/video_output/vout_pictures.c
===================================================================
RCS file: /var/cvs/videolan/vlc/src/video_output/vout_pictures.c,v
retrieving revision 1.45
diff -u -r1.45 vout_pictures.c
--- src/video_output/vout_pictures.c	25 Jan 2004 17:16:06 -0000	1.45
+++ src/video_output/vout_pictures.c	21 Feb 2004 23:12:46 -0000
@@ -398,8 +398,8 @@
     }
     else
     {
-        *pi_width = __MIN( i_width, p_vout->render.i_width );
-        *pi_height = __MIN( i_height, p_vout->render.i_height );
+        *pi_width = __MIN( i_width, p_vout->render.i_width * p_vout->f_zoom );
+        *pi_height = __MIN( i_height, p_vout->render.i_height * p_vout->f_zoom );
     }
 
     if( VOUT_ASPECT_FACTOR * *pi_width / *pi_height < p_vout->render.i_aspect )
